// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.ArrayList;

/**
 * Verwaltet einen ungerichteten, gewichteten Graphen mittels Adjazenzlisten
 * @author Albert Wiedemann @version 1.0
 */
public class GraphListe
{
    /* Feld der Knoten des Graphen*/
    private ArrayList<Knoten> knoten;
    /* Feld der Kantensymbole des Graphen*/
    private ArrayList<KantenSymbol> kanten;

    /* Die Warteliste (ToDo-Liste) Neue Felder ergänzen*/

    /**
     * Baut die Datenstruktur auf
     */
    protected GraphListe()
    {
        knoten = new ArrayList < Knoten > ( );
        kanten = new ArrayList < KantenSymbol > ( );
        /* Initialisierung der neuen Felder ergänzen*/
    }

    /**
     * Einfügen eines neuen Knoten in den Graphen @param bezeichner Bezeichner des neuen Knotens, der dem Graphen hinzugefügt wird. @param x x-Koordinate für die Anzeige des Knotens @param y y-Koordinate für die Anzeige des Knotens
     */
    protected void KnotenEinfügen(String bezeichner, int x, int y)
    {
        knoten . add ( new Knoten ( bezeichner , x , y ) );
    }

    /**
     * Gibt den Knoten mit dem angegebenen Bezeichner zurück. Wenn ein Knoten mit diesem Bezeichner nicht bekannt ist wird null zurückgegeben @param bezeichner Bezeichner des Knoten der gesucht wird @return Referenz auf das Knotenobjekt oder null
     */
    protected Knoten KnotenGeben(String bezeichner)
    {
        for (final Knoten k : knoten) {
            if (k . BezeichnerGeben ( ) . equals ( bezeichner )) {
                return k;
            }
        }
        return null;
    }

    /**
     * Gibt die interne Nummer des Knotens Wenn ein Knoten mit diesem Bezeichner nicht bekannt ist wird -1 zurückgegeben @param bezeichner Bezeichner des Knoten der gesucht wird @return Indexnummer des Knotens im Knotenfeld; 0 <= res <= knoten.size()-1 bzw. -1
     */
    private int KnotenNummerGeben(String bezeichner)
    {
        int index = 0;
        while (index < knoten . size ( )) {
            if (knoten . get ( index ) . BezeichnerGeben ( ) . equals ( bezeichner )) {
                return index;
            }
            index = index + 1;
        }
        return - 1;
    }

    /**
     * Gibt die Bezeichnung eines Knotens mit der internen Knotennummer @param Indexnummer des Knotens im Knotenarray; 0<= x <= knoten.size() @return Bezeichner des Knotens
     */
    protected String KnotenBezeichnerGeben(int knotenNummer)
    {
        if (( knotenNummer < knoten . size ( ) ) && ( knotenNummer >= 0 )) {
            return knoten . get ( knotenNummer ) . BezeichnerGeben ( );
        }
        else {
            return "";
        }
    }

    /**
     * Einfügen einer Kante in den Graphen Eine Kante ist durch einen Anfangsknoten und einen Endknoten festgelegt und hat eine Gewichtung @param von Bezeichner des Anfangsknotens @param nach Bezeichner des Endknotens @param gewichtung Gewichtung der Kante als Ganzzahl
     */
    protected void KanteEinfügen(String von, String nach, int gewichtung)
    {
        int vonNummer;
        int nachNummer;
        vonNummer = KnotenNummerGeben ( von );
        nachNummer = KnotenNummerGeben ( nach );
        if (( vonNummer != - 1 ) && ( nachNummer != - 1 ) && ( vonNummer != nachNummer )) {
            knoten . get ( vonNummer ) . AdjazenzlisteGeben ( ) . add ( new Kante ( gewichtung , knoten . get ( nachNummer ) ) );
            knoten . get ( nachNummer ) . AdjazenzlisteGeben ( ) . add ( new Kante ( gewichtung , knoten . get ( vonNummer ) ) );
            kanten . add ( new KantenSymbol ( knoten . get ( vonNummer ) . SymbolGeben ( ) , knoten . get ( nachNummer ) . SymbolGeben ( ) , false , "" + gewichtung , 3 , "blau" ) );
        }
    }

    /**
     * Gibt die Adjazenzlisten der Knoten auf der Konsole aus Für jeden Knoten wird die Liste der Ziele mit Gewichten ausgegeben
     */
    protected void Ausgeben()
    {
        for (final Knoten k : knoten) {
            System . out . print ( k . BezeichnerGeben ( ) + ": " );
            for (final Kante ka : k . AdjazenzlisteGeben ( )) {
                System . out . print ( "(" + ka . GewichtGeben ( ) + "-> " + ka . ZielGeben ( ) . BezeichnerGeben ( ) + ") " );
            }
            System . out . println ( );
        }
    }

    /**
     * Gibt die Anzahl der Knoten des Graphen zurück @return  Anzahl der Knoten
     */
    protected int KnotenAnzahlgeben()
    {
        return knoten . size ( );
    }

    /**
     * Gibt die Gewichtung einer Kante zurück Die Kante ist durch einen Anfangsknoten und einen Endknoten festgelegt @param von Bezeichner des Anfangsknotens @param nach Bezeichner des Endknotens @return Gewichtung der Kante
     */
    protected int KanteGewichtGeben(String von, String nach)
    {
        int vonNummer;
        Knoten nachKnoten;
        vonNummer = KnotenNummerGeben ( von );
        nachKnoten = KnotenGeben ( nach );
        if (( vonNummer != - 1 ) && ( nachKnoten != null )) {
            for (final Kante k : knoten . get ( vonNummer ) . AdjazenzlisteGeben ( )) {
                if (k . ZielGeben ( ) == nachKnoten) {
                    return k . GewichtGeben ( );
                }
            }
            return - 1;
        }
        else {
            return - 1;
        }
    }

    /**
     * Löscht die Kanten und Knoten des Graphen Die Anzeige wird auch gelöscht
     */
    protected void ZurückSetzen()
    {
        for (final KantenSymbol k : kanten) {
            k . Entfernen ( );
        }
        for (final Knoten k : knoten) {
            k . SymbolGeben ( ) . Entfernen ( );
        }
        knoten . clear ( );
        kanten . clear ( );
    }

    /**
     * 
     */
    protected void Umwandeln(ArrayList<ArrayList<Integer>> matrix)
    {
        int zeile = 0;
        while (zeile <= matrix . size ( )) {
            int spalte = zeile + 1;
            while (spalte <= matrix . get ( zeile ) . size ( )) {
                int gewichtung = matrix . get ( zeile ) . get ( spalte );
                knoten . get ( zeile ) . AdjazenzlisteGeben ( ) . add ( new Kante ( gewichtung , knoten . get ( spalte ) ) );
                knoten . get ( spalte ) . AdjazenzlisteGeben ( ) . add ( new Kante ( gewichtung , knoten . get ( zeile ) ) );
                kanten . add ( new KantenSymbol ( knoten . get ( zeile ) . SymbolGeben ( ) , knoten . get ( spalte ) . SymbolGeben ( ) , false , "" + gewichtung , 3 , "blau" ) );
                spalte = spalte + 1;
            }
            zeile = zeile + 1;
        }
    }

    /**
     * Führt die Breitensuche vom Startknoten zum Zielknoten durch @param startKnoten der Startknoten @param zielKnoten der Zielknoten
     */
    protected void BreitensucheAusführen(Knoten startKnoten, Knoten zielKnoten)
    {
        /* Algorithmus ergänzen Fertigmeldung anzeigen*/
    }
}
