// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.ArrayList;

/**
 * Verwaltet einen ungerichteten, gewichteten Graphen mittels Adjazenzmatrix
 * @author Albert Wiedemann @version 1.0
 */
public class GraphMatrix
{
    /* Feld der Knoten des Graphen*/
    private ArrayList<Knoten> knoten;
    /* 2-dim Feld der Adjazenzmatrix*/
    private ArrayList<ArrayList<Integer>> matrix;
    /* Feld der Kantensymbole des Graphen*/
    private ArrayList<KantenSymbol> kanten;

    /**
     * Baut die Datenstruktur auf
     */
    protected GraphMatrix()
    {
        knoten = new ArrayList < Knoten > ( );
        matrix = new ArrayList < ArrayList < Integer >> ( );
        kanten = new ArrayList < KantenSymbol > ( );
    }

    /**
     * Einfügen eines neuen Knoten in den Graphen @param x x-Koordinate des Knotens @param y y-Koordinate des Knotens
     */
    protected void KnotenEinfügen(int x, int y)
    {
        knoten . add ( new Knoten ( x , y ) );
        int index = 0;
        while (index < matrix . size ( )) {
            matrix . get ( index ) . add ( new Integer ( - 1 ) );
            index = index + 1;
        }
        matrix . add ( new ArrayList < Integer > ( ) );
        int index = 0;
        while (index < matrix . size ( ) - 1) {
            matrix . get ( matrix . size ( ) - 1 ) . add ( new Integer ( - 1 ) );
            index = index + 1;
        }
        matrix . get ( matrix . size ( ) - 1 ) . add ( new Integer ( 0 ) );
    }

    /**
     * Gibt die interne Nummer des Knotens Wenn ein Knoten mit diesen Koordinaten nicht bekannt ist wird -1 zurückgegeben @param x x-Koordinate des Knotens @param y y-Koordinate des Knotens @return Indexnummer des Knotens im Knotenfeld; 0 <= res <= knoten.size()-1 bzw. -1
     */
    private int KnotenNummerGeben(int x, int y)
    {
        int index = 0;
        while (index < knoten . size ( )) {
            Knoten k = knoten . get ( index );
            if (( k . XGeben ( ) == x ) && ( k . YGeben ( ) == y )) {
                return index;
            }
            index = index + 1;
        }
        return - 1;
    }

    /**
     * Gibt die interne Nummer des Knotens @param k der Knoten @return Indexnummer des Knotens im Knotenfeld; 0 <= res <= knoten.size()-1 bzw. -1
     */
    private int KnotenNummerGeben(Knoten k)
    {
        int index = 0;
        while (index < knoten . size ( )) {
            if (knoten . get ( index ) == k) {
                return index;
            }
            index = index + 1;
        }
        return - 1;
    }

    /**
     * Einfügen einer Kante in den Graphen Eine Kante ist durch einen Anfangsknoten und einen Endknoten festgelegt und hat eine Gewichtung @param x1 x-Koordinate des Anfangsknotens @param y1 y-Koordinate des Anfangsknotens @param x2 x-Koordinate des Endknotens @param y2 y-Koordinate des Endknotens
     */
    protected void KanteEinfügen(int x1, int y1, int x2, int y2)
    {
        int vonNummer;
        int nachNummer;
        vonNummer = KnotenNummerGeben ( x1 , y1 );
        nachNummer = KnotenNummerGeben ( x2 , y2 );
        if (( vonNummer != - 1 ) && ( nachNummer != - 1 ) && ( vonNummer != nachNummer )) {
            matrix . get ( vonNummer ) . set ( nachNummer , 1 );
            matrix . get ( nachNummer ) . set ( vonNummer , 1 );
            kanten . add ( new KantenSymbol ( knoten . get ( vonNummer ) . SymbolGeben ( ) , knoten . get ( nachNummer ) . SymbolGeben ( ) , false , "" , 3 , "blau" ) );
        }
    }

    /**
     * Gibt die Anzahl der Knoten des Graphen zurück @return  Anzahl der Knoten
     */
    private int KnotenAnzahlgeben()
    {
        return knoten . size ( );
    }

    /**
     * Führt die Breitensuche zum Testen des Zusammenhangs durch Falls am Ende alle Knoten besucht wurden, ist der Graph zusammenhängend @return WAHR, wenn der Graph zusammenhängend ist.
     */
    protected boolean ZusammenhangTesten()
    {
        /* Nach Aufgabenstellung ergänzen*/
        return false;
    }
}
